#ifndef _DECL_NeighborLB_H_
#define _DECL_NeighborLB_H_
#include "charm++.h"
#include "NborBaseLB.decl.h"

/* DECLS: group NeighborLB: NborBaseLB{
void NeighborLB(void);
};
 */
class NeighborLB;
class CProxy_NeighborLB:  public virtual _CK_GID, public CProxy_NborBaseLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_NeighborLB(CkGroupID _gid) :CProxy_NborBaseLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_NeighborLB(CkChareID __cid) :CProxy_NborBaseLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    NeighborLB* ckLocalBranch(void) {
      return (NeighborLB *) CkLocalBranch(_ck_gid);
    }
    static NeighborLB* ckLocalBranch(CkGroupID gID) {
      return (NeighborLB *) CkLocalBranch(gID);
    }
/* DECLS: void NeighborLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_NeighborLB(int retEP, CkChareID *cid);
    CProxy_NeighborLB(void);
    static int  __idx_NeighborLB_void;
    static int  ckIdx_NeighborLB(void) { return __idx_NeighborLB_void; }
    static void _call_NeighborLB_void(void* msg, NeighborLB* obj);
};

extern void _registerNeighborLB(void);
#endif
